/*
* Copyright 1998-2009 VIA Technologies, Inc. All Rights Reserved.
* Copyright 2001-2009 S3 Graphics, Inc. All Rights Reserved.
*
* Permission is hereby granted, free of charge, to any person obtaining a
* copy of this software and associated documentation files (the "Software"),
* to deal in the Software without restriction, including without limitation
* the rights to use, copy, modify, merge, publish, distribute, sub license,
* and/or sell copies of the Software, and to permit persons to whom the
* Software is furnished to do so, subject to the following conditions:
*
* The above copyright notice and this permission notice (including the
* next paragraph) shall be included in all copies or substantial portions
* of the Software.
*
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
* IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
* FITNESS FOR A PARTICULAR PURPOSE AND NON-INFRINGEMENT. IN NO EVENT SHALL
* THE AUTHOR(S) OR COPYRIGHT HOLDER(S) BE LIABLE FOR ANY CLAIM, DAMAGES OR
* OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
* ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
* DEALINGS IN THE SOFTWARE.
*/
#ifndef _DISP_AD9389_H_
#define _DISP_AD9389_H_

#include <xf86Priv.h>

typedef enum 
{
    OPTION_HDMI_TYPE,
    OPTION_HDMI_DIPORT,
    OPTION_HDMI_SERIALPORT,
    OPTION_HDMI_DDCPORT,
    OPTION_HDMI_Hotplug,
    OPTION_HDMI_CLOCK_POLARITY,
    OPTION_HDMI_CLOCK_ADJUST,
    OPTION_HDMI_CLOCK_DRIVING_SELECTION,
    OPTION_HDMI_DATA_DRIVING_SELECTION,
    OPTION_HDMI_ATTACH_ALL_MODES
}ViaHdmiOpts;

typedef struct via_HDMI_InfoFrameRec
{
    CARD16 PacketHeader[3];
    CARD16 ECCCode;
    CARD16 PacketByte[28];
    CARD16 BCHCode[4];
} viaHDMI_InfoFrameRec;

static OptionInfoRec ViaHdmiOptions[] =
{
    {OPTION_HDMI_TYPE,       "Type",         OPTV_STRING,    {0}, FALSE},
    {OPTION_HDMI_DIPORT,     "DIPort",       OPTV_STRING,    {0}, FALSE},
    {OPTION_HDMI_SERIALPORT, "SerialPort",   OPTV_INTEGER,   {0}, FALSE},
    {OPTION_HDMI_DDCPORT,    "DDCPort",      OPTV_INTEGER,   {0}, FALSE},
    {OPTION_HDMI_Hotplug,    "Hotplug",      OPTV_BOOLEAN,   {0}, FALSE},    
    {OPTION_HDMI_CLOCK_POLARITY,         "ClockPolarity",        OPTV_INTEGER,   {0}, FALSE},
    {OPTION_HDMI_CLOCK_ADJUST,           "ClockAdjust",          OPTV_INTEGER,   {0}, FALSE},
    {OPTION_HDMI_CLOCK_DRIVING_SELECTION,"ClockDrivingSelection",OPTV_INTEGER,   {0}, FALSE},
    {OPTION_HDMI_DATA_DRIVING_SELECTION, "DataDrivingSelection", OPTV_INTEGER,   {0}, FALSE},    
    {OPTION_HDMI_ATTACH_ALL_MODES,     "AttachAllModes",  OPTV_BOOLEAN,   {0}, FALSE},    
    {-1,                    NULL,           OPTV_NONE,      {0}, FALSE} 
};


void via_hdmi_init(ScrnInfoPtr pScrn, const char* name);
extern _X_EXPORT Bool viaGetStdEDIDBlock(CARD32 serialPort, CARD8* pEDIDData);
extern _X_EXPORT Bool viaGetExtEDIDBlock(CARD32 serialPort, CARD8* pEDIDData, CARD8 extFlag);
extern _X_EXPORT CARD32 viaDetectConnectType(CARD8* extEdid);
extern _X_EXPORT void viaFindMaxSupportMode(ScrnInfoPtr pScrn, CARD8* stdEdid, CARD8* extEDID,
                             CARD32* maxWidth, CARD32* maxHeight);
#endif
